from dataclasses import dataclass, field

from .base import Paysite, Service_Post, Service_User


@dataclass
class User(Service_User):
    def profile(self, artist: dict) -> str:
        return f"https://fansly.com/{(artist or {}).get('id')}"


@dataclass
class Post(Service_Post):
    def link(self, post_id: str, user_id: str) -> str:
        return f"https://fansly.com/post/{post_id}/"


@dataclass
class Fansly(Paysite):
    name: str = "fansly"
    title: str = "Fansly"
    user: User = field(default_factory=User)
    post: Post = field(default_factory=Post)
    color: str = "#2399f7"
